"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _assert() {
  const data = _interopRequireDefault(require("assert"));

  _assert = function _assert() {
    return data;
  };

  return data;
}

function _chalk() {
  const data = _interopRequireDefault(require("chalk"));

  _chalk = function _chalk() {
    return data;
  };

  return data;
}

function _emptyDir() {
  const data = _interopRequireDefault(require("empty-dir"));

  _emptyDir = function _emptyDir() {
    return data;
  };

  return data;
}

function _clearModule() {
  const data = _interopRequireDefault(require("clear-module"));

  _clearModule = function _clearModule() {
    return data;
  };

  return data;
}

function _path() {
  const data = require("path");

  _path = function _path() {
    return data;
  };

  return data;
}

function _launchEditor() {
  const data = _interopRequireDefault(require("react-dev-utils/launchEditor"));

  _launchEditor = function _launchEditor() {
    return data;
  };

  return data;
}

function _openBrowser() {
  const data = _interopRequireDefault(require("react-dev-utils/openBrowser"));

  _openBrowser = function _openBrowser() {
    return data;
  };

  return data;
}

function _fs() {
  const data = require("fs");

  _fs = function _fs() {
    return data;
  };

  return data;
}

function _child_process() {
  const data = require("child_process");

  _child_process = function _child_process() {
    return data;
  };

  return data;
}

function _got() {
  const data = _interopRequireDefault(require("got"));

  _got = function _got() {
    return data;
  };

  return data;
}

function _lodash() {
  const data = require("lodash");

  _lodash = function _lodash() {
    return data;
  };

  return data;
}

function _rimraf() {
  const data = _interopRequireDefault(require("rimraf"));

  _rimraf = function _rimraf() {
    return data;
  };

  return data;
}

function _portfinder() {
  const data = _interopRequireDefault(require("portfinder"));

  _portfinder = function _portfinder() {
    return data;
  };

  return data;
}

function _resolveFrom() {
  const data = _interopRequireDefault(require("resolve-from"));

  _resolveFrom = function _resolveFrom() {
    return data;
  };

  return data;
}

var _Config = _interopRequireDefault(require("./Config"));

var _getClientScript = _interopRequireDefault(require("./getClientScript"));

var _listDirectory = _interopRequireDefault(require("./listDirectory"));

var _installCreator = _interopRequireDefault(require("./installCreator"));

var _npmClient = require("./npmClient");

var _ActiveProjectError = _interopRequireDefault(require("./ActiveProjectError"));

var _Actions = require("./Actions");

var _checkProject = require("./checkProject");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const debug = require('debug')('umiui:UmiUI');

class UmiUI {
  constructor() {
    this.cwd = void 0;
    this.servicesByKey = void 0;
    this.server = void 0;
    this.socketServer = void 0;
    this.logs = void 0;
    this.config = void 0;
    this.send = void 0;
    this.developMode = false;
    this.cwd = process.cwd();
    this.servicesByKey = {};
    this.server = null;
    this.socketServer = null;
    this.config = new _Config.default({
      onSave: data => {
        if (this.send) {
          this.send({
            type: '@@project/list/progress',
            payload: data
          });
        }
      }
    });
    this.logs = [];
    this.developMode = !!process.env.DEVELOP_MODE;

    if (process.env.CURRENT_PROJECT) {
      this.config.addProjectAndSetCurrent(process.env.CURRENT_PROJECT);
    }
  }

  activeProject(key, service, opts) {
    const _ref = opts || {},
          lang = _ref.lang;

    const project = this.config.data.projectsByKey[key];
    (0, _assert().default)(project, `project of key ${key} not exists`); // Check exists.

    if (!(0, _fs().existsSync)(project.path)) {
      throw new _ActiveProjectError.default({
        message: {
          'zh-CN': `项目 ${project.path} 路径不存在。`,
          'en-US': `Project ${project.path} not exists.`
        },
        lang,
        actions: [_Actions.BackToHomeAction]
      });
    } // Check umi valid.


    if (!(0, _checkProject.isUmiProject)(project.path)) {
      throw new _ActiveProjectError.default({
        message: {
          'zh-CN': `项目 ${project.path} 不是 Umi 项目。`,
          'en-US': `Project ${project.path} is not a valid Umi project.`
        },
        lang,
        actions: [_Actions.BackToHomeAction]
      });
    }

    if (!this.developMode && service) {
      this.servicesByKey[key] = service;
    } else if (!this.servicesByKey[key]) {
      // Attach Service
      debug(`Attach service for ${key}`); // Use local service and detect version compatibility

      const serviceModule = process.env.BIGFISH_COMPAT ? '@alipay/bigfish/_Service' : 'umi/_Service';
      const binModule = process.env.BIGFISH_COMPAT ? '@alipay/bigfish/bin/bigfish' : 'umi/bin/umi';
      const cwd = project.path;

      const localService = _resolveFrom().default.silent(cwd, serviceModule);

      const localBin = _resolveFrom().default.silent(cwd, binModule); // TODO: 上线前删除 false 判断


      if (false && localBin && !localService) {
        // 有 Bin 但没 Service，说明版本不够
        throw new _ActiveProjectError.default({
          message: process.env.BIGFISH_COMPAT ? `Bigfish 版本过低，请升级到 @alipay/bigfish@2.20 或以上。` : {
            'zh-CN': `Umi 版本过低，请升级到 umi@2.9 或以上。`,
            'en-US': `Umi version is too low, please upgrade to umi@2.9 or above.`
          },
          lang,
          actions: [_Actions.BackToHomeAction, _Actions.OpenProjectAction]
        });
      }

      try {
        const servicePath = localService || 'umi-build-dev/lib/Service';
        debug(`Service path: ${servicePath}`);

        const Service = require(servicePath).default;

        const service = new Service({
          cwd: project.path
        });
        debug(`Attach service for ${key} after new and before init()`);
        service.init();
        debug(`Attach service for ${key} ${_chalk().default.green('SUCCESS')}`);
        this.servicesByKey[key] = service;
      } catch (e) {
        console.error('service eee', e);

        if ((0, _checkProject.isDepLost)(e)) {
          throw new _ActiveProjectError.default({
            message: {
              'zh-CN': `依赖文件没找到。`,
              'en-US': 'Dependency file not found.'
            },
            lang,
            actions: [_Actions.ReInstallDependencyAction, _Actions.BackToHomeAction]
          });
        } else {
          throw new _ActiveProjectError.default({
            message: {
              'zh-CN': '其他错误',
              'en-US': 'Other Errors'
            },
            lang,
            // exception tag
            exception: true,
            actions: [_Actions.BackToHomeAction]
          });
        }
      }
    }

    this.config.setCurrentProject(key);
    this.config.editProject(key, {
      opened_at: +new Date()
    });
  }

  openProjectInEditor(key) {
    if (key.startsWith('/') && (0, _fs().existsSync)(key)) {
      (0, _launchEditor().default)(key, 1);
    } else {
      const project = this.config.data.projectsByKey[key];
      (0, _assert().default)(project, `project of key ${key} not exists`);
      (0, _launchEditor().default)(project.path, 1);
    }
  }

  openConfigFileInEditor(projectPath) {
    let configFile;
    const configFiles = ['.umirc.js', '.umirc.ts', 'config/config.js', 'config/config.ts'];

    for (var _i = 0, _configFiles = configFiles; _i < _configFiles.length; _i++) {
      const file = _configFiles[_i];

      if ((0, _fs().existsSync)((0, _path().join)(projectPath, file))) {
        configFile = (0, _path().join)(projectPath, file);
        break;
      }
    }

    (0, _assert().default)(configFile, `configFile not exists`);
    (0, _launchEditor().default)(configFile, 1);
  }

  getExtraAssets() {
    const service = this.servicesByKey[this.config.data.currentProject];
    const uiPlugins = service.applyPlugins('addUIPlugin', {
      initialValue: []
    });
    const script = (0, _getClientScript.default)(uiPlugins);
    return {
      script
    };
  }

  installDeps(npmClient, projectPath, {
    onProgress,
    onSuccess
  }) {
    return _asyncToGenerator(function* () {
      yield (0, _npmClient.installDeps)(npmClient, projectPath, {
        onData(data) {
          onProgress({
            install: data
          });
        }

      });
      onSuccess();
    })();
  }

  createProject(opts = {}, {
    onSuccess,
    onFailure,
    onProgress
  }) {
    var _this = this;

    return _asyncToGenerator(function* () {
      const type = opts.type,
            npmClient = opts.npmClient,
            baseDir = opts.baseDir,
            name = opts.name,
            args = opts.args;
      let key;

      const setProgress = args => {
        (0, _assert().default)(key, `key is not initialized.`);

        _this.config.setCreatingProgress(key, args);

        onProgress(_this.config.data.projectsByKey[key].creatingProgress);
      };

      try {
        // 步骤：
        //
        // 1. 校验
        //      a) 比如检查目标目录是否为空或不存在
        // 2. 添加项目状态到本地存储，后面每一步都更新状态到存储
        // 3. 安装 create-umi 或更新他
        // 4. create-umi 创建
        //    如果是 ant-design-pro，还需要拆几步出来，比如 git clone
        // 5. 安装依赖
        //
        // 项目步骤：
        // 1. 校验参数
        // 2. 安装/更新 create-umi
        // 3. 使用 create-umi 初始化项目
        // 4. 安装依赖
        //
        // 结束后打开项目。
        (0, _assert().default)(baseDir, `baseDir must be supplied`);
        (0, _assert().default)(name, `name must be supplied`);
        (0, _assert().default)(type, `type must be supplied`);
        const targetDir = (0, _path().join)(baseDir, name); // 1

        (0, _assert().default)(!(0, _fs().existsSync)(targetDir) || _emptyDir().default.sync(targetDir), `target dir ${targetDir} exists and not empty`); // 2

        key = _this.config.addProject(targetDir, name); // get create key

        onSuccess({
          key
        }); // catch exit

        process.on('SIGINT', () => {
          if (key) {
            try {
              _this.config.setCreatingProgress(key, {
                stepStatus: 3,
                failure: {
                  message: 'exit UmiUi server'
                }
              });
            } catch (e) {}
          }

          process.exit();
        });
        setProgress({
          // 表示第几个 step，从 0 开始
          step: 1,
          // 0: 未开始
          // 1: 执行中
          // 2: 执行完成
          // 3: 执行失败
          stepStatus: 0,
          steps: ['校验参数', '安装或更新 create-umi', '初始化项目文件', '安装依赖']
        }); // 3

        setProgress({
          step: 1,
          stepStatus: 1
        });
        const creatorPath = yield (0, _installCreator.default)({});
        setProgress({
          stepStatus: 2
        }); // 4

        setProgress({
          step: 2,
          stepStatus: 1
        });
        (0, _clearModule().default)(creatorPath);
        yield require(creatorPath).run({
          cwd: targetDir,
          type,
          args
        });
        setProgress({
          stepStatus: 2
        }); // 5

        setProgress({
          step: 3,
          stepStatus: 1
        });
        yield (0, _npmClient.installDeps)(npmClient, targetDir, {});
        setProgress({
          stepStatus: 2
        });
        setProgress({
          success: true
        }); // this.config.setCreatingProgressDone(key);
        // onSuccess();
      } catch (e) {
        if (key) {
          _this.config.setCreatingProgress(key, {
            stepStatus: 3,
            failure: e
          });
        }

        onFailure(e);
      } finally {
        process.removeListener('SIGINT', () => {
          console.log('success remove sigint');
        });
      }
    })();
  }

  checkDirValid({
    dir
  }, {
    onSuccess,
    onFailure
  }) {
    try {
      // 入参校验
      (0, _assert().default)(dir, `payload.dir must be supplied`);

      if (!(0, _fs().existsSync)(dir)) {
        return onSuccess();
      } // 非目录判断和权限校验


      const stat = (0, _fs().statSync)(dir);
      (0, _assert().default)(stat.isDirectory(), `target directory must be a directory`); // 费空目录判断

      (0, _assert().default)(_emptyDir().default.sync(dir), `target directory must be empty`);
    } catch (e) {
      onFailure(e);
    }
  }

  getNpmClients() {
    const ret = [];

    try {
      (0, _child_process().execSync)('tnpm --version', {
        stdio: 'ignore'
      });
      ret.push('tnpm');
    } catch (e) {}

    try {
      (0, _child_process().execSync)('cnpm --version', {
        stdio: 'ignore'
      });
      ret.push('cnpm');
    } catch (e) {}

    try {
      (0, _child_process().execSync)('npm --version', {
        stdio: 'ignore'
      });
      ret.push('npm');
    } catch (e) {}

    try {
      (0, _child_process().execSync)('ayarn --version', {
        stdio: 'ignore'
      });
      ret.push('ayarn');
    } catch (e) {}

    try {
      (0, _child_process().execSync)('yarn --version', {
        stdio: 'ignore'
      });
      ret.push('yarn');
    } catch (e) {}

    try {
      (0, _child_process().execSync)('pnpm --version', {
        stdio: 'ignore'
      });
      ret.push('pnpm');
    } catch (e) {}

    return ret;
  }

  reloadProject(key) {}

  handleCoreData({
    type,
    payload,
    lang
  }, {
    log,
    send,
    success,
    failure,
    progress
  }) {
    switch (type) {
      case '@@project/getExtraAssets':
        success(this.getExtraAssets());
        break;

      case '@@project/list':
        log('info', 'list project');
        success({
          data: this.config.data
        });
        break;

      case '@@project/add':
        // TODO: 检验是否 umi 项目，不是则抛错给客户端
        try {
          (0, _assert().default)((0, _fs().existsSync)(payload.path), `Add project failed, since path ${payload.path} don't exists.`);
          log('info', `add project ${payload.path} with name ${payload.name}`);
          this.config.addProject(payload.path, payload.name);
          success();
        } catch (e) {
          console.error(_chalk().default.red(`Error: Add project FAILED`));
          console.error(e);
          failure({
            message: e.message
          });
        }

        break;

      case '@@project/delete':
        log('info', `delete project`);
        this.config.deleteProject(payload.key);
        success();
        break;

      case '@@project/open':
        log('info', `open project`);

        try {
          this.activeProject(payload.key, null, {
            lang
          });
          success();
        } catch (e) {
          console.error(_chalk().default.red(`Error: Attach Project of key ${payload.key} FAILED`));
          console.error(e);
          failure((0, _lodash().pick)(e, ['message', 'stack', 'actions', 'exception']));
        }

        break;

      case '@@project/openInEditor':
        log('info', `open project in editor`);
        this.openProjectInEditor(payload.key);
        success();
        break;

      case '@@project/edit':
        log('info', `edit project`); // 只支持改名

        this.config.editProject(payload.key, {
          name: payload.name
        });
        success();
        break;

      case '@@project/setCurrentProject':
        log('info', `set current project`);
        this.config.setCurrentProject(payload.key);
        success();
        break;

      case '@@project/create':
        log('info', `create project`);
        this.createProject(payload, {
          onSuccess: success,

          onFailure(e) {
            failure({
              message: e.message
            });
          },

          onProgress: progress
        });
        break;

      case '@@project/checkDirValid':
        this.checkDirValid(payload, {
          onSuccess: success,

          onFailure(e) {
            failure({
              message: e.message
            });
          }

        });
        break;

      case '@@project/createTemplateList':
        success({
          data: [{
            title: 'Ant Design Pro',
            description: 'A layout-only ant-design-pro boilerplate, use together with umi block',
            url: 'https://preview.pro.ant.design/'
          }, {
            title: 'Basic Template',
            description: 'A simple boilerplate, support typescript.'
          }]
        });
        break;

      case '@@project/getNpmClients':
        success({
          data: this.getNpmClients()
        });
        break;

      case '@@fs/getCwd':
        success({
          cwd: this.cwd
        });
        break;

      case '@@fs/listDirectory':
        success({
          data: (0, _listDirectory.default)(payload.dirPath, {
            directoryOnly: true
          })
        });
        break;

      case '@@log/getHistory':
        success({
          data: this.logs
        });
        break;

      case '@@log/clear':
        this.logs = [];
        success();
        break;

      case '@@actions/installDependencies':
        this.installDeps(payload.npmClient, payload.projectPath, {
          onProgress: progress,
          onSuccess: success
        });
        break;

      case '@@actions/reInstallDependencies':
        _rimraf().default.sync((0, _path().join)(payload.projectPath, 'node_modules'));

        this.installDeps(payload.npmClient, payload.projectPath, {
          onProgress: progress,
          onSuccess: success
        });
        break;

      case '@@actions/openConfigFile':
        this.openConfigFileInEditor(payload.projectPath);
        success();
        break;

      case '@@actions/openProjectInEditor':
        this.openProjectInEditor(payload.projectPath);
        success();
        break;

      case '@@app/notify':
        try {
          const notifier = require('node-notifier');

          const buildInImages = {
            error: (0, _path().resolve)(__dirname, 'assets', 'error.png'),
            info: (0, _path().resolve)(__dirname, 'assets', 'info.png'),
            success: (0, _path().resolve)(__dirname, 'assets', 'success.png'),
            warning: (0, _path().resolve)(__dirname, 'assets', 'warning.png')
          };

          const type = payload.type,
                restPayload = _objectWithoutProperties(payload, ["type"]);

          const noticeConfig = _objectSpread({}, restPayload, {
            contentImage: buildInImages[type] || buildInImages.info,
            icon: (0, _path().resolve)(__dirname, 'assets', 'umi.png'),
            sound: true
          });

          notifier.notify(noticeConfig);
          success();
        } catch (e) {
          console.error(_chalk().default.red(`Error: Notify for ${e.message} FAILED`));
          failure(e);
        }

        break;

      default:
        log('error', _chalk().default.red(`Unhandled message type ${type}`));
        break;
    }
  }

  start() {
    var _this2 = this;

    return _asyncToGenerator(function* () {
      return new Promise(
      /*#__PURE__*/
      function () {
        var _ref2 = _asyncToGenerator(function* (resolve, reject) {
          const express = require('express');

          const compression = require('compression');

          const app = express();
          app.use(compression()); // Index Page

          let content = null; // Serve Static (Production Only)

          if (!process.env.LOCAL_DEBUG) {
            app.use(express.static((0, _path().join)(__dirname, '../client/dist')));
          }

          app.use((req, res) => {
            if (['/'].includes(req.path)) {
              if (process.env.LOCAL_DEBUG) {
                (0, _got().default)(`http://localhost:8002${req.path}`).then(({
                  body
                }) => {
                  res.set('Content-Type', 'text/html');
                  res.send(normalizeHtml(body));
                }).catch(e => {
                  console.error(e);
                });
              } else {
                if (!content) {
                  content = (0, _fs().readFileSync)((0, _path().join)(__dirname, '../client/dist/index.html'), 'utf-8');
                }

                res.send(normalizeHtml(content));
              }
            }
          }); // 添加埋点脚本

          function normalizeHtml(html) {
            const ga = `
<!-- Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-145890626-1"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-145890626-1');
</script>
        `;
            const deer = `
<script>
  !function(t,e,a,r,c){t.TracertCmdCache=t.TracertCmdCache||[],t[c]=window[c]||
  {_isRenderInit:!0,call:function(){t.TracertCmdCache.push(arguments)},
  start:function(t){this.call('start',t)}},t[c].l=new Date;
  var n=e.createElement(a),s=e.getElementsByTagName(a)[0];
  n.async=!0,n.src=r,s.parentNode.insertBefore(n,s);
  n.onerror=function(){console.warn(decodeURI('Tracert%20%E8%84%9A%E6%9C%AC%E6%9C%AA%E6%88%90%E5%8A%9F%E5%8A%A0%E8%BD%BD,%20%E8%AF%B7%E6%A3%80%E6%9F%A5%E7%BD%91%E7%BB%9C%E4%BB%A5%E5%8F%8A%20A%20%E4%BD%8D%E6%98%AF%E5%90%A6%E5%9C%A8%E4%B9%9D%E8%89%B2%E9%B9%BF%E5%BB%BA%E7%AB%8B%E6%B4%9E%E5%AF%9F'));
  var fallback=function(){console.warn(decodeURI('Tracert%20%E5%91%BD%E4%BB%A4%E6%89%A7%E8%A1%8C%E5%A4%B1%E8%B4%A5%EF%BC%8C%E8%AF%B7%E6%A3%80%E6%9F%A5%20JS%20%E6%98%AF%E5%90%A6%E6%AD%A3%E7%A1%AE%E5%BC%95%E5%85%A5'))};
  for(var fnlist=["call","start","config","logPv","info","err","click","expo","pageName","pageState","time","timeEnd","parse","checkExpo","stringify","report","set","before"],i=0;i<fnlist.length;i++){t[c][fnlist[i]]=fallback}};
  }(window,document,'script','https://ur.alipay.com/tracert_a1613.js','Tracert');
  Tracert.start({
  });
</script>
        `;

            if (process.env.BIGFISH_COMPAT) {
              html = html.replace('<body>', '<body>\n<script>window.g_bigfish = {};</script>');
            }

            if (!process.env.LOCAL_DEBUG) {
              const baconScript = process.env.BIGFISH_COMPAT ? deer : ga;
              html = html.replace('</head>', `${baconScript}\n</head>`);
            }

            return html;
          }

          const sockjs = require('sockjs');

          const ss = sockjs.createServer();
          const conns = {};

          function send(action) {
            const message = JSON.stringify(action);
            console.log(_chalk().default.green.bold('>>>>'), formatLogMessage(message));
            Object.keys(conns).forEach(id => {
              conns[id].write(message);
            });
          }

          function formatLogMessage(message) {
            let ret = message.length > 500 ? `${message.slice(0, 500)} ${_chalk().default.gray('...')}` : message;
            ret = ret.replace(/{"type":"(.+?)"/, `{"type":"${_chalk().default.magenta.bold('$1')}"`);
            return ret;
          }

          ss.on('connection', conn => {
            conns[conn.id] = conn;
            console.log(`😀 ${_chalk().default.green('建立连接')}: ${conn.id}`);

            function success(type, payload) {
              send({
                type: `${type}/success`,
                payload
              });
            }

            function failure(type, payload) {
              send({
                type: `${type}/failure`,
                payload
              });
            }

            function progress(type, payload) {
              send({
                type: `${type}/progress`,
                payload
              });
            }

            _this2.send = send;

            const log = (type, message) => {
              const payload = {
                date: +new Date(),
                type,
                message
              };
              console[type === 'error' ? 'error' : 'log'](`${_chalk().default.gray(`[${type}]`)} ${message}`);

              _this2.logs.push(payload);

              send({
                type: '@@log/message',
                payload
              });
            };

            conn.on('close', () => {
              console.log(`😭 ${_chalk().default.red('断开连接')}: ${conn.id}`);
              delete conns[conn.id];
            });
            conn.on('data', message => {
              try {
                const _JSON$parse = JSON.parse(message),
                      type = _JSON$parse.type,
                      payload = _JSON$parse.payload,
                      lang = _JSON$parse.lang;

                console.log(_chalk().default.blue.bold('<<<<'), formatLogMessage(message));

                if (type.startsWith('@@')) {
                  _this2.handleCoreData({
                    type,
                    payload,
                    lang
                  }, {
                    log,
                    send,
                    success: success.bind(_this2, type),
                    failure: failure.bind(_this2, type),
                    progress: progress.bind(_this2, type)
                  });
                } else if (_this2.config.data.currentProject) {
                  const service = _this2.servicesByKey[_this2.config.data.currentProject];
                  service.applyPlugins('onUISocket', {
                    args: {
                      action: {
                        type,
                        payload,
                        lang
                      },
                      log,
                      send,
                      success: success.bind(_this2, type),
                      failure: failure.bind(_this2, type),
                      progress: progress.bind(_this2, type)
                    }
                  });
                } // eslint-disable-next-line no-empty

              } catch (e) {
                console.error(_chalk().default.red(e.stack));
              }
            });
          });
          _portfinder().default.basePort = 3000;
          _portfinder().default.highestPort = 3333;
          const port = process.env.PORT || (yield _portfinder().default.getPortPromise());
          const server = app.listen(port, process.env.HOST || '127.0.0.1', err => {
            if (err) {
              reject(err);
            } else {
              const url = `http://localhost:${port}/`;
              console.log(`umi ui listening on port ${port}`);
              console.log(url);
              (0, _openBrowser().default)(url);
              resolve();
            }
          });
          ss.installHandlers(server, {
            prefix: '/umiui'
          });
          _this2.socketServer = ss;
          _this2.server = server;
        });

        return function (_x, _x2) {
          return _ref2.apply(this, arguments);
        };
      }());
    })();
  }

}

exports.default = UmiUI;