"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.executeCommand = executeCommand;
exports.installDeps = installDeps;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function _react() {
    return data;
  };

  return data;
}

function _execa() {
  const data = _interopRequireDefault(require("execa"));

  _execa = function _execa() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function executeCommand(_x, _x2, _x3) {
  return _executeCommand.apply(this, arguments);
}

function _executeCommand() {
  _executeCommand = _asyncToGenerator(function* (npmClient, args, targetDir, opts = {}) {
    return new Promise((resolve, reject) => {
      // args.push('--registry=https://registry.npm.taobao.org');
      const child = (0, _execa().default)(npmClient, args, {
        cwd: targetDir,
        stdio: ['inherit', 'pipe', 'pipe']
      });
      child.stdout.on('data', buffer => {
        process.stdout.write(buffer);
        if (opts.onData) opts.onData(buffer.toString());
      });
      child.stderr.on('data', buffer => {
        process.stderr.write(buffer);
        if (opts.onData) opts.onData(buffer.toString());
      });
      child.on('close', code => {
        if (code !== 0) {
          reject(new Error(`command failed: ${npmClient} ${args.join(' ')}`));
          return;
        }

        resolve();
      });
    });
  });
  return _executeCommand.apply(this, arguments);
}

function installDeps(_x4, _x5, _x6) {
  return _installDeps.apply(this, arguments);
}

function _installDeps() {
  _installDeps = _asyncToGenerator(function* (npmClient, targetDir, opts) {
    const yarnClients = ['yarn', 'ayarn', 'tyarn'];
    const args = yarnClients.includes(npmClient) ? [] : ['install'];
    yield executeCommand(npmClient, args, targetDir, opts);
  });
  return _installDeps.apply(this, arguments);
}